#pragma once

#include "DisplayData.h"
// EditTrialImagesDialog dialog

class CEditTrialImagesDialog : public CDialog
{
	DECLARE_DYNAMIC(CEditTrialImagesDialog)

public:
	CEditTrialImagesDialog(CWnd* pParent, DisplayData dd, unsigned int whichDisp);   // standard constructor
	virtual ~CEditTrialImagesDialog();


	void Initialize(DisplayData dd, unsigned int whichDisp);
	BOOL OnInitDialog();
	DisplayData getDisplayData();
// Dialog Data
	enum { IDD = IDD_EDIT_TRIAL_ADD_IMAGES_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
private:
	DisplayData _display;
	unsigned int _whichDisplay;
	std::vector<IMAGEPOS> *images;

public:
	afx_msg void OnLbnSelChangeImagePos();
	afx_msg void OnBnClickedAddImagesOk();
	afx_msg void OnBnClickedAddImagesCancel();
	afx_msg void OnBnClickedButtonAddImage();
	afx_msg void OnBnClickedButtonUpdateImage();
	afx_msg void OnBnClickedButtonDeleteImage();
	afx_msg void OnBnClickedButtonBrowseImages();
	afx_msg void OnEnChangeEditAddImagePath();
};
