#include ".\serial.h"


Serial::Serial(void)
{
}

Serial::~Serial(void)
{


}
#ifdef NOT_DEFINED
int Serial::OriginalOpenPort(CString &result)
{
	char szBuffer[512];
	int size = sizeof(szBuffer);

	ovlr.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	ovlw.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	m_hCommPort = 
		CreateFile(	"COM1:", 
					GENERIC_READ | GENERIC_WRITE,
					0, 
					NULL, 
					OPEN_EXISTING, 
					FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED  /*| FILE_FLAG_NO_BUFFERING*/,
					NULL);

	if(m_hCommPort == INVALID_HANDLE_VALUE) return FALSE;

	dcb.DCBlength = sizeof(dcb);

	if(!GetCommState(m_hCommPort, &dcb)){
		error = DCB_GET_COMM_STATE;
	}
	dcb.DCBlength = sizeof(dcb);
	dcb.BaudRate = CBR_19200;
	dcb.fParity = FALSE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fTXContinueOnXoff = TRUE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fErrorChar = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_ENABLE;
	dcb.fAbortOnError = FALSE;
	dcb.XonLim = 0x800;
	dcb.XoffLim = 0x200;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.XonChar = 0;
	dcb.XoffChar = 0;
	dcb.ErrorChar = 0;
	dcb.EvtChar = 0;
	dcb.EofChar = 0; 
	if(!SetCommState(m_hCommPort, &dcb)){
		error = -1;
	}

	//GetCommState(m_hCommPort, &dcb);
	cto.ReadIntervalTimeout = 0xffffffff;  
	cto.ReadTotalTimeoutMultiplier = 0;  
	cto.ReadTotalTimeoutConstant = 0;    
	cto.WriteTotalTimeoutMultiplier = 0;  
	cto.WriteTotalTimeoutConstant = 1000;  

	/*cto.ReadIntervalTimeout = 1000;  
	cto.ReadTotalTimeoutMultiplier = 1000;  
	cto.ReadTotalTimeoutConstant = 1000;    
	cto.WriteTotalTimeoutMultiplier = 1000;  
	cto.WriteTotalTimeoutConstant = 1000;  */


	eyemsg_printf("Sending AT1\r\n");
	SetCommTimeouts(m_hCommPort, &cto);
	
	DWORD err;
	unsigned char readBuffer[25600];
//	if(ReadFile(m_hCommPort, szBuffer, sizeof(szBuffer), &dwRead, &ovlr) == 0){


	unsigned char newBuffer[1];
	newBuffer[0] = 0xE1;
	dwRead = 0;

	WriteFile(m_hCommPort, newBuffer, 1, &dwWritten, &ovlw);
	err = GetLastError();


	while(!ReadFile(m_hCommPort, readBuffer, 25000/*sizeof(readBuffer)*/, &dwRead, &ovlr)){
		GetOverlappedResult(m_hCommPort, &ovlr, &dwRead, TRUE);
		for(int i=0;i<5000; i++){
			if (readBuffer[i])
				eyemsg_printf("%d", readBuffer[i]);
		}
	}
	ReadFile(m_hCommPort, readBuffer, 5000/*sizeof(readBuffer)*/, &dwRead, &ovlr);
	err = GetLastError();

	// changes 
	GetOverlappedResult(m_hCommPort, &ovlr, &dwRead, TRUE);
	CloseHandle(m_hCommPort);
	return TRUE;

	// END changes


	//while(err == ERROR_IO_PENDING){
	//	GetOverlappedResult(m_hCommPort, &ovlr, &dwRead, FALSE);
	//	err = GetLastError();
	//}

	CString buffer = "0xE0";

	char buf[10];
	int i = 0;
	bool didit = false;
	int lastError = 0;
	if(!WriteFile(m_hCommPort, newBuffer, 1, &dwWritten, &ovlw)){
		//buffer = "ATI";
		//itoa(i, buf, 10);
		//buffer.Append(buf);
		//buffer.Append("\r");

		buffer = "0xE";
		itoa(i, buf, 10);
		buffer.Append(buf);
	//	buffer.Append("\r");
		i++;
		i %= 10;

	//} //original end of while loop
	

	if( GetOverlappedResult(m_hCommPort, &ovlr, &dwRead, TRUE) ){
		//szBuffer[dwRead] = 0;
		eyemsg_printf("Received: (bytes=%d), %s\r\n", strlen(szBuffer), szBuffer);
		//CloseHandle(m_hCommPort);
		result.SetString(szBuffer, sizeof(szBuffer));
		//return dwRead;
		//return 10;
		didit = true;

		
		WriteFile(m_hCommPort,newBuffer, 1, &dwWritten, &ovlw);
	//	if(ReadFile(m_hCommPort, szBuffer, sizeof(szBuffer), &dwRead, &ovlr) == 0){
	//	if(ReadFile(m_hCommPort, &readBuffer, sizeof(readBuffer), &dwRead, &ovlr) == 0){
	//		err = GetLastError();
	//	}	
	//	else {
	//		eyemsg_printf("gotdata");
	//	}
	}
	// getOverlapped failed
	err = GetLastError();
	
	}
//	else {
	if (!didit){
		eyemsg_printf("no overlapped results\n");
		CloseHandle(m_hCommPort);
	}
	else{
		CloseHandle(m_hCommPort);
		return 10;
	}
	return TRUE;
}

#endif 

int Serial::OpenPort(CString &result)
{
	ovlr.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	ovlw.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	m_hCommPort = 
		CreateFile(	"COM1:", 
		GENERIC_READ | GENERIC_WRITE,
		0, 
		NULL, 
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED  /*| FILE_FLAG_NO_BUFFERING*/,
		NULL);

	if(m_hCommPort == INVALID_HANDLE_VALUE) return FALSE;

	dcb.DCBlength = sizeof(dcb);

	if(!GetCommState(m_hCommPort, &dcb)){
		error = DCB_GET_COMM_STATE;
	}
	dcb.DCBlength = sizeof(dcb);
	dcb.BaudRate = CBR_19200;
	dcb.fParity = FALSE;
	dcb.fOutxCtsFlow = FALSE;
	dcb.fOutxDsrFlow = FALSE;
	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.fDsrSensitivity = FALSE;
	dcb.fTXContinueOnXoff = TRUE;
	dcb.fOutX = FALSE;
	dcb.fInX = FALSE;
	dcb.fErrorChar = FALSE;
	dcb.fNull = FALSE;
	dcb.fRtsControl = RTS_CONTROL_ENABLE;
	dcb.fAbortOnError = FALSE;
	dcb.XonLim = 0x800;
	dcb.XoffLim = 0x200;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.XonChar = 0;
	dcb.XoffChar = 0;
	dcb.ErrorChar = 0;
	dcb.EvtChar = 0;
	dcb.EofChar = 0; 
	if(!SetCommState(m_hCommPort, &dcb)){
		error = -1;
	}

	//GetCommState(m_hCommPort, &dcb);
/*	cto.ReadIntervalTimeout = 0xffffffff;  
	cto.ReadTotalTimeoutMultiplier = 0;  
	cto.ReadTotalTimeoutConstant = 0;    
	cto.WriteTotalTimeoutMultiplier = 0;  
	cto.WriteTotalTimeoutConstant = 1000;  */

	cto.ReadIntervalTimeout = 1000;  
	cto.ReadTotalTimeoutMultiplier = 1000;  
	cto.ReadTotalTimeoutConstant = 1000;    
	cto.WriteTotalTimeoutMultiplier = 1000;  
	cto.WriteTotalTimeoutConstant = 1000; 

	SetCommTimeouts(m_hCommPort, &cto);



	dwRead = 0;


	


	return TRUE;
}

int Serial::ClosePort(){
	CloseHandle(m_hCommPort);
	return 0;
}

int Serial::getData(){
	GetOverlappedResult(m_hCommPort, &ovlr, &dwRead, TRUE);
	return 0;
}

int Serial::StartDataRecording(int buffersize){

	unsigned char newBuffer[1];
	newBuffer[0] = 0xE1;
	WriteFile(m_hCommPort, newBuffer, 1, &dwWritten, &ovlw);

	ReadFile(m_hCommPort, readBuffer, buffersize/*sizeof(readBuffer)*/, &dwRead, &ovlr);

	return 0;
}

int Serial::getFirst(){
	for(int i=0; i<25000; i++)
		if(readBuffer[i] >= 64)
			return i;
	return -1;
}

int Serial::getLast(){
	for(int i = 24999; i >= 0; i--)
		if(readBuffer[i] >= 64)
			return i;
	return -1;
}